;unix.h: 39: typedef unsigned short uint16;
;unix.h: 40: typedef short int16;
;unix.h: 41: typedef unsigned char uchar;
;unix.h: 43: typedef struct s_queue {
;unix.h: 44:     char *q_base;
;unix.h: 45:     char *q_head;
;unix.h: 46:     char *q_tail;
;unix.h: 47:     int q_size;
;unix.h: 48:     int q_count;
;unix.h: 49:     int q_wakeup;
;unix.h: 50: } queue_t;
;unix.h: 54: typedef struct time_s {
;unix.h: 55:     uint16 t_time;
;unix.h: 56:     uint16 t_date;
;unix.h: 57: } time_t;
;unix.h: 62: struct tms {
;unix.h: 63: 	time_t  tms_utime;
;unix.h: 64: 	time_t  tms_stime;
;unix.h: 65: 	time_t  tms_cutime;
;unix.h: 66: 	time_t  tms_cstime;
;unix.h: 67: 	time_t  tms_etime;
;unix.h: 68: } ;
;unix.h: 77: typedef struct off_t {
;unix.h: 78:     uint16 o_blkno;
;unix.h: 79:     int16 o_offset;
;unix.h: 80: } off_t;
;unix.h: 83: typedef uint16 blkno_t;
;unix.h: 87: typedef struct blkbuf {
;unix.h: 88:     char        bf_data[512];
;unix.h: 89:     char        bf_dev;
;unix.h: 90:     blkno_t     bf_blk;
;unix.h: 91:     char        bf_dirty;
;unix.h: 92:     char        bf_busy;
;unix.h: 93:     uint16      bf_time;
;unix.h: 95: } blkbuf, *bufptr;
;unix.h: 98: typedef struct dinode {
;unix.h: 99:     uint16 i_mode;
;unix.h: 100:     uint16 i_nlink;
;unix.h: 101:     uint16 i_uid;
;unix.h: 102:     uint16 i_gid;
;unix.h: 103:     off_t    i_size;
;unix.h: 104:     time_t   i_atime;
;unix.h: 105:     time_t   i_mtime;
;unix.h: 106:     time_t   i_ctime;
;unix.h: 107:     blkno_t  i_addr[20];
;unix.h: 108: } dinode;
;unix.h: 111: struct  stat
;unix.h: 112: {
;unix.h: 113: 	int16   st_dev;
;unix.h: 114: 	uint16  st_ino;
;unix.h: 115: 	uint16  st_mode;
;unix.h: 116: 	uint16  st_nlink;
;unix.h: 117: 	uint16  st_uid;
;unix.h: 118: 	uint16  st_gid;
;unix.h: 119: 	uint16  st_rdev;
;unix.h: 120: 	off_t   st_size;
;unix.h: 121: 	time_t  st_atime;
;unix.h: 122: 	time_t  st_mtime;
;unix.h: 123: 	time_t  st_ctime;
;unix.h: 124: };
;unix.h: 154: typedef struct cinode {
;unix.h: 155:     int    c_magic;
;unix.h: 156:     int    c_dev;
;unix.h: 157:     unsigned   c_num;
;unix.h: 158:     dinode   c_node;
;unix.h: 159:     char     c_refs;
;unix.h: 160:     char     c_dirty;
;unix.h: 161: } cinode, *inoptr;
;unix.h: 167: typedef struct direct {
;unix.h: 168:     uint16 d_ino;
;unix.h: 169:     char     d_name[14];
;unix.h: 170: } direct;
;unix.h: 174: typedef struct filesys {
;unix.h: 175:     int16       s_mounted;
;unix.h: 176:     uint16      s_isize;
;unix.h: 177:     uint16      s_fsize;
;unix.h: 178:     int16       s_nfree;
;unix.h: 179:     blkno_t     s_free[50];
;unix.h: 180:     int16       s_ninode;
;unix.h: 181:     uint16      s_inode[50];
;unix.h: 182:     int16       s_fmod;
;unix.h: 183:     time_t      s_time;
;unix.h: 184:     blkno_t     s_tfree;
;unix.h: 185:     uint16      s_tinode;
;unix.h: 186:     inoptr      s_mntpt;
;unix.h: 187: } filesys, *fsptr;
;unix.h: 189: typedef struct oft {
;unix.h: 190:     off_t       o_ptr;
;unix.h: 191:     inoptr      o_inode;
;unix.h: 192:     char        o_access;
;unix.h: 193:     char        o_refs;
;unix.h: 194: } oft;
;unix.h: 233: typedef struct p_tab {
;unix.h: 234:     char        p_status;
;unix.h: 235:     int p_pid;
;unix.h: 236:     int p_uid;
;unix.h: 237:     struct p_tab *p_pptr;
;unix.h: 238:     blkno_t     p_swap;
;unix.h: 239:     unsigned    p_alarm;
;unix.h: 240:     unsigned    p_exitval;
;unix.h: 242:     char       *p_wait;
;unix.h: 243:     int p_priority;
;unix.h: 244:     uint16      p_pending;
;unix.h: 245:     uint16      p_ignored;
;unix.h: 246: } p_tab, *ptptr;
_OSYS equ 2     ;byte offsets of elements of u_data
;unix.h: 251: _OSYS equ 2     ;byte offsets of elements of u_data
_OCALL equ 3
;unix.h: 252: _OCALL equ 3
_ORET equ 4     ;return location
;unix.h: 253: _ORET equ 4     ;return location
_ORVAL equ 6    ;return value
;unix.h: 254: _ORVAL equ 6    ;return value
_OERR equ 8     ;error number
;unix.h: 255: _OERR equ 8     ;error number
_OSP equ 10     ;users stack pointer
;unix.h: 256: _OSP equ 10     ;users stack pointer
_OBC equ 12     ;users frame pointer
;unix.h: 257: _OBC equ 12     ;users frame pointer
;unix.h: 260: typedef struct u_data {
;unix.h: 261:     struct p_tab *u_ptab;
;unix.h: 262:     char        u_insys;
;unix.h: 263:     char        u_callno;
;unix.h: 264:     char        *u_retloc;
;unix.h: 265:     int         u_retval;
;unix.h: 266:     int         u_error;
;unix.h: 267:     char        *u_sp;
;unix.h: 268:     char        *u_bc;
;unix.h: 269:     int         u_argn;
;unix.h: 270:     int         u_argn1;
;unix.h: 271:     int         u_argn2;
;unix.h: 272:     int         u_argn3;
;unix.h: 274:     char *      u_base;
;unix.h: 275:     unsigned    u_count;
;unix.h: 276:     off_t       u_offset;
;unix.h: 277:     struct blkbuf *u_buf;
;unix.h: 279:     int         u_gid;
;unix.h: 280:     int         u_euid;
;unix.h: 281:     int         u_egid;
;unix.h: 282:     int         u_mask;
;unix.h: 283:     time_t      u_time;
;unix.h: 284:     char        u_files[10    ];
;unix.h: 286:     inoptr      u_cwd;
;unix.h: 287:     char        *u_break;
;unix.h: 289:     inoptr      u_ino;
;unix.h: 290:     char        *u_isp;
;unix.h: 292:     int         (*u_sigvec[16        ])();
;unix.h: 293:     int         u_cursig;
;unix.h: 294:     char        u_name[8];
;unix.h: 295:     time_t      u_utime;
;unix.h: 296:     time_t      u_stime;
;unix.h: 297:     time_t      u_cutime;
;unix.h: 298:     time_t      u_cstime;
;unix.h: 300: } u_data;
;unix.h: 304: struct s_argblk {
;unix.h: 305:     int a_argc;
;unix.h: 306:     int a_arglen;
;unix.h: 307:     int a_envc;
;unix.h: 308:     char a_buf[512-3*sizeof(int)];
;unix.h: 309: };
;unix.h: 314: typedef struct devsw {
;unix.h: 315:     int minor;
;unix.h: 316:     int (*dev_open)();
;unix.h: 317:     int (*dev_close)();
;unix.h: 318:     int (*dev_read)();
;unix.h: 319:     int (*dev_write)();
;unix.h: 320:     int (*dev_ioctl)();
;unix.h: 321: } devsw;
;P:EXTRAS.C: 7: void bcopy( char *src, char *dest, int count ) {
psect	text
global	_bcopy
_bcopy:
global	ncsv, cret, indir
call	ncsv
defw	f1
	ld	l, (ix+6)	; src
;P:EXTRAS.C: 9: 	ld	l, (ix+6)	; src
	ld	h, (ix+7)
;P:EXTRAS.C: 10: 	ld	h, (ix+7)
	ld	e, (ix+8)	; dest
;P:EXTRAS.C: 11: 	ld	e, (ix+8)	; dest
	ld	d, (ix+9)
;P:EXTRAS.C: 12: 	ld	d, (ix+9)
	ld	c, (ix+10)	; count
;P:EXTRAS.C: 13: 	ld	c, (ix+10)	; count
	ld	b, (ix+11)
;P:EXTRAS.C: 14: 	ld	b, (ix+11)
	ldir
;P:EXTRAS.C: 15: 	ldir
;P:EXTRAS.C: 17: }
l16:
jp	cret
f1	equ	0
;P:EXTRAS.C: 19: void bzero( char *ptr, int count ) {
global	_bzero
_bzero:
call	ncsv
defw	f2
	ld	l, (ix+6)	; src
;P:EXTRAS.C: 21: 	ld	l, (ix+6)	; src
	ld	h, (ix+7)
;P:EXTRAS.C: 22: 	ld	h, (ix+7)
	ld	e, l		; dest
;P:EXTRAS.C: 23: 	ld	e, l		; dest
	ld	d, h
;P:EXTRAS.C: 24: 	ld	d, h
	inc	de
;P:EXTRAS.C: 25: 	inc	de
	ld	c, (ix+8)	; count
;P:EXTRAS.C: 26: 	ld	c, (ix+8)	; count
	ld	b, (ix+9)
;P:EXTRAS.C: 27: 	ld	b, (ix+9)
	ldir
;P:EXTRAS.C: 28: 	ldir
;P:EXTRAS.C: 30: }
l17:
jp	cret
f2	equ	0
;P:EXTRAS.C: 33: abort()
;P:EXTRAS.C: 34: {
global	_abort
_abort:
call	ncsv
defw	f3
        di
;P:EXTRAS.C: 36:         di
        jp     $
;P:EXTRAS.C: 37:         jp     $
;P:EXTRAS.C: 39: }
l18:
jp	cret
f3	equ	0
;P:EXTRAS.C: 60: char *__longtoa(unsigned long value, char *strP, int radix,
;P:EXTRAS.C: 61: 			char maybeSigned, char hexStyle) {
global	___longtoa
___longtoa:
call	ncsv
defw	f4
;P:EXTRAS.C: 62: 	char buf[34];
;P:EXTRAS.C: 63: 	register char *di = strP, *si = buf;
ld	l,(ix+10)
ld	h,(ix+1+10)
push	hl
pop	iy
push	ix
pop	de
ld	hl,-34
add	hl,de
ld	(ix+-36),l
ld	(ix+1+-36),h
;P:EXTRAS.C: 64: 	uint16 *p = (uint16 *)&value;
push	ix
pop	de
ld	hl,6
add	hl,de
ld	(ix+-38),l
ld	(ix+1+-38),h
;P:EXTRAS.C: 65: 	unsigned char al, cx;
;P:EXTRAS.C: 67: 	hexStyle -= 10;
ld	a,(ix+16)
add	a,.low.-10
ld	(ix+16),a
;P:EXTRAS.C: 69: 	if (radix > 36 || radix < 2)
ld	e,(ix+12)
ld	d,(ix+1+12)
ld	hl,36
global	wrelop
call	wrelop
jp	age,20f
jp	21f
20:
ld	de,2
ld	l,(ix+12)
ld	h,(ix+1+12)
global	wrelop
call	wrelop
jp	age,20f
jp	21f
21:jp	11f
20:jp	10f
10:
jp	l20
11:
;P:EXTRAS.C: 70: 		goto lta_end;
jp	l21
;P:EXTRAS.C: 71: 	if (p[1] & 0x8000 && maybeSigned) {
l20:
ld	l,(ix+-38)
ld	h,(ix+1+-38)
inc	hl
inc hl
ld	c,(hl)
inc	hl
ld	b,(hl)
bit	15&7,b
jp	z,20f
jp	21f
21:
ld	a,(ix+14)
or	a
jp	az,20f
jp	21f
21:jp	11f
20:jp	10f
10:
jp	l22
11:
;P:EXTRAS.C: 72: 		*di++ = '-';
ld	(iy+0),45
inc	iy
;P:EXTRAS.C: 73: 		value = -value;
ld	e,(ix+6)
ld	d,(ix+1+6)
ld	l,(ix+2+6)
ld	h,(ix+3+6)
push	hl
push	de
ld	hl,0
pop	bc
or	a
sbc	hl,bc
pop	bc
ex	de,hl
ld	hl,0
sbc	hl,bc
ld	(ix+6),e
ld	(ix+1+6),d
ld	(ix+2+6),l
ld	(ix+3+6),h
;P:EXTRAS.C: 74: 	}
;P:EXTRAS.C: 80: 	if (p[1] == 0)
l22:
ld	l,(ix+-38)
ld	h,(ix+1+-38)
inc	hl
inc hl
ld	a,(hl)
inc	hl
or	(hl)
jp	nz,l23
;P:EXTRAS.C: 81: 		goto lta_shortLoop;
jp	l24
;P:EXTRAS.C: 82: 	do {
l23:
l27:
;P:EXTRAS.C: 83: 		*si++ = (uchar)(value % radix);
ld	e,(ix+12)
ld	d,(ix+1+12)
ld	hl,0
push	hl
push	de
ld	e,(ix+6)
ld	d,(ix+1+6)
ld	l,(ix+2+6)
ld	h,(ix+3+6)
global	llmod
call	llmod
ld	e,e
ld	l,(ix+-36)
ld	h,(ix+1+-36)
inc	hl
ld	(ix+-36),l
ld	(ix+1+-36),h
dec	hl
ld	(hl),e
;P:EXTRAS.C: 84: 		value /= radix;
ld	e,(ix+12)
ld	d,(ix+1+12)
ld	hl,0
push	hl
push	de
push	ix
pop	de
ld	hl,6
add	hl,de
global	aslldiv
call	aslldiv
;P:EXTRAS.C: 85: 	} while (p[1] != 0);
l25:
ld	l,(ix+-38)
ld	h,(ix+1+-38)
inc	hl
inc hl
ld	a,(hl)
inc	hl
or	(hl)
jp	nz,l27
l26:
;P:EXTRAS.C: 86: 	goto lta_shortTest;
jp	l28
;P:EXTRAS.C: 88: lta_shortLoop:
l24:
;P:EXTRAS.C: 89: 	 do {
l31:
;P:EXTRAS.C: 90: 		*si++ = (uchar)((uint16)value % radix);
ld	e,(ix+12)
ld	d,(ix+1+12)
ld	l,(ix+6)
ld	h,(ix+1+6)
global	lmod
call	lmod
ld	a,l
ld	l,(ix+-36)
ld	h,(ix+1+-36)
inc	hl
ld	(ix+-36),l
ld	(ix+1+-36),h
dec	hl
ld	(hl),a
;P:EXTRAS.C: 91: 		p[0] = ((uint16)value / radix);
ld	e,(ix+12)
ld	d,(ix+1+12)
ld	l,(ix+6)
ld	h,(ix+1+6)
global	ldiv
call	ldiv
ex	de,hl
ld	l,(ix+-38)
ld	h,(ix+1+-38)
ld	(hl),e
inc	hl
ld	(hl),d
;P:EXTRAS.C: 92: lta_shortTest:	;
l28:
;P:EXTRAS.C: 93: 	} while (p[0] != 0);
l29:
ld	l,(ix+-38)
ld	h,(ix+1+-38)
ld	a,(hl)
inc	hl
or	(hl)
jp	nz,l31
l30:
;P:EXTRAS.C: 97: 	cx = (uchar)(si-buf);
push	ix
pop	de
ld	hl,-34
add	hl,de
ex	de,hl
ld	l,(ix+-36)
ld	h,(ix+1+-36)
or	a
sbc	hl,de
ld	l,l
ld	(ix+-40),l
;P:EXTRAS.C: 101: 	while (cx != 0) {
jp	l32
l33:
;P:EXTRAS.C: 102: 		al = *--si;
ld	l,(ix+-36)
ld	h,(ix+1+-36)
dec	hl
ld	(ix+-36),l
ld	(ix+1+-36),h
ld	l,(hl)
ld	(ix+-39),l
;P:EXTRAS.C: 103: 		if (al < 10)
ld	b,.low.10
ld	a,(ix+-39)
global	brelop
call	brelop
jp	lge,l35
;P:EXTRAS.C: 104: 			al += '0';
ld	a,(ix+-39)
add	a,.low.48
ld	(ix+-39),a
;P:EXTRAS.C: 105: 		else	al += hexStyle;
jp	l36
l35:
ld	a,(ix+-39)
add	a,(ix+16)
ld	(ix+-39),a
l36:
;P:EXTRAS.C: 106: 		*di++ = al;
ld	a,(ix+-39)
ld	(iy+0),a
inc	iy
;P:EXTRAS.C: 107: 		--cx;
ld	a,(ix+-40)
add	a,.low.-1
ld	(ix+-40),a
;P:EXTRAS.C: 108: 	}
l32:
ld	a,(ix+-40)
or	a
jp	lnz,l33
l34:
;P:EXTRAS.C: 110: lta_end:
l21:
;P:EXTRAS.C: 111: 	*di = 0;
ld	(iy+0),0
;P:EXTRAS.C: 112: 	return	strP;
ld	l,(ix+10)
ld	h,(ix+1+10)
jp	l19
;P:EXTRAS.C: 113: }
l19:
jp	cret
f4	equ	-40
;P:EXTRAS.C: 154: char *itoa(value, strP, radix)
;P:EXTRAS.C: 155: 	int value;
;P:EXTRAS.C: 156: 	char *strP;
;P:EXTRAS.C: 157: 	int radix;
;P:EXTRAS.C: 158: {
global	_itoa
_itoa:
call	ncsv
defw	f5
;P:EXTRAS.C: 159: 	char hex = 'A';
ld	(ix+-1),65
;P:EXTRAS.C: 161: 	if (radix < 0) {
bit	7,(ix+1+10)
jp	z,l38
;P:EXTRAS.C: 162: 		hex = 'a';
ld	(ix+-1),97
;P:EXTRAS.C: 163: 		radix = -radix;
ld	e,(ix+10)
ld	d,(ix+1+10)
ld	hl,0
or	a
sbc	hl,de
ld	(ix+10),l
ld	(ix+1+10),h
;P:EXTRAS.C: 164: 	}
;P:EXTRAS.C: 165: 	return	__longtoa ((radix == 10) ? (long) value :
l38:
;P:EXTRAS.C: 166: 			   (unsigned long)((unsigned)value),
;P:EXTRAS.C: 167: 			   strP, radix, 1, hex);
ld	l,(ix+-1)
push	hl
ld	l,.low.1
push	hl
ld	l,(ix+10)
ld	h,(ix+1+10)
push	hl
ld	l,(ix+8)
ld	h,(ix+1+8)
push	hl
ld	de,10
ld	l,(ix+10)
ld	h,(ix+1+10)
or	a
sbc	hl,de
jp	z,10f
jp	11f
11:
ld	e,(ix+6)
ld	d,(ix+1+6)
ld	hl,0
jp	12f
10:
ld	e,(ix+6)
ld	d,(ix+1+6)
ld	a,d
rla
sbc	a,a
ld	l,a
ld	h,a
12:
push	hl
push	de
call	___longtoa
exx
ld	hl,4+2+2+2+2
add	hl,sp
ld	sp,hl
exx
ld	l,l
ld	h,h
jp	l37
;P:EXTRAS.C: 168: }
l37:
jp	cret
f5	equ	-1
 167: 			   strP, radix, 1, hex);
ld	l,(ix+-1)
push	hl
ld	l,.low.1
push	hl
ld	l,(ix+10